﻿local Clock_Version = "|cFFFFFF00 2.1.0";
local Clock_BuildDate = "|cFFFFFF00Build Date|r :|cFF00FFAA 10.10.29";
local TimeSinceLastUpdate = 0
local BG_Color = 0

if (not SoW_Clock) then -- 이 설정은 WTF 파일이 없는(최초 설치시) 경우에 설정되는 기본 사항입니다.
	SoW_Clock = {};
	SoW_Clock.MemSet = 0; -- 메모리 표시 종류 설정| 0=통합, 1=애드온, 2=와우기본UI
	SoW_Clock.MemSize = 25; -- 경고 시작할 메모리 용량
	SoW_Clock.TipSet = 0; -- 툴팁 표시 설정
	SoW_Clock.TipList = 30; -- 애드온 표시 리스트 갯수 설정
	SoW_Clock.TimeType = 0; -- 시간 표시 방법 설정 | 0 = 12시간 단위, 1 = 24시간 단위
	SoW_Clock.Scale = 1; -- 애드온의 크기 비율
	SoW_Clock.OClock = true; -- 정시 알림 소리 설정 | false = 미사용, true = 사용
	SoW_Clock.CleanTime = 5; -- 자동 메모리 정리 간격 | 단위는 분, 0일 경우 미사용
end

local ClockFrame = CreateFrame("Button", "SoW_Clock_Frame", UIParent) 
ClockFrame:SetPoint("CENTER", UIParent, "CENTER", x, y)
ClockFrame:SetHeight(38)
ClockFrame:SetWidth(160)
ClockFrame:SetMovable(true)
ClockFrame:SetUserPlaced(true)
ClockFrame:EnableMouse("false")

ClockFrame:RegisterEvent("PLAYER_ENTERING_WORLD")
ClockFrame:RegisterEvent("UPDATE_SHAPESHIFT_FORM")

local ClockFrame_BackGround = ClockFrame:CreateTexture(nil, "BACKGROUND")
ClockFrame_BackGround:SetAllPoints(ClockFrame)
ClockFrame_BackGround:SetTexture(0, 0, 0, 0)
--ClockFrame_BackGround:Hide()

local TimeShadowString =  ClockFrame:CreateFontString(nil, "OVERLAY")
TimeShadowString:SetPoint("CENTER", ClockFrame, "CENTER", -30, 5)
TimeShadowString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 26)
TimeShadowString:SetTextColor(1,1,1)

local TimeString =  ClockFrame:CreateFontString(nil, "OVERLAY")
TimeString:SetPoint("CENTER", ClockFrame, "CENTER", -31, 6)
TimeString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 26)
TimeString:SetTextColor(0,0.6,1)

local DateString = ClockFrame:CreateFontString(nil, "OVERLAY")
DateString:SetPoint("CENTER", ClockFrame, "CENTER", 49, 10.5)
DateString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 12)
--DateString:SetTextColor(0.8,0.8,0.8)

local MidnSecString = ClockFrame:CreateFontString(nil, "OVERLAY")
MidnSecString:SetPoint("CENTER", ClockFrame, "CENTER", 36.5, -0.65)
MidnSecString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrogrammaDBExt.TTF", 12)
MidnSecString:SetTextColor(0.8,0.8,0.8)

local WeekString = ClockFrame:CreateFontString(nil, "OVERLAY")
WeekString:SetPoint("CENTER", ClockFrame, "CENTER", 64, 0.5)
WeekString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\NHNGodicB.TTF", 12)
--WeekString:SetTextColor(0.8,0.8,0.8)

local InfoString = ClockFrame:CreateFontString(nil, "OVERLAY")
InfoString:SetPoint("CENTER", ClockFrame, "CENTER", 0, -11)
InfoString:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\MicrostyleBEAtt.TTF", 12)
--InfoString:SetTextColor(0.8,0.8,0.8)

ClockFrame:SetScript("OnUpdate", function(self, elapsed)
  Now = date("%S");
	
	if ( Now ~= TimeSinceLastUpdate ) then
	
  	if CalendarGetNumPendingInvites() > 0 then -- 미응답 일정 갯수 반환함수
  	  if BG_Color == 0 then
        ClockFrame_BackGround:SetTexture(0, 0.6, 1, 0.75)
        BG_Color = 1
      elseif BG_Color == 1 then
        ClockFrame_BackGround:SetTexture(1, 0, 0.6, 0.75)
        BG_Color = 2
      elseif BG_Color == 2 then
        ClockFrame_BackGround:SetTexture(0.6, 1, 0, 0.75)
        BG_Color = 0
      end
  else
    ClockFrame_BackGround:SetTexture(0, 0, 0, 0)
  end
	
  SoW_Clock_Frame:SetScale(SoW_Clock.Scale*1)
  
  local l_WeekName = {"|CFFFF4444일|r","월","화","수","목","금","|CFF4444BB토|r"};
	local l_DateText = string.format("%s%s%s",date("|cFFFFCC00%m|r"),"|cFFFFFFFF/|r",date("|cFFFFCC00%d|r"));
	local l_DateText1; -- 시각 표시
	local l_DateText2; -- 오전/후 or 초 표시
  if ( SoW_Clock.TimeType == 0 ) then
  	l_DateText1 = date("%I:%M");
  	l_DateText2 = date("%p");
  else
    l_DateText1 = date("%H:%M");
    l_DateText2 = date("%S");
  end
  
--local hour, minute = GetGameTime()
--print(hour .. ":" .. minute) UTC
--print(date("%H") .. ":" .. date("%M")) 클라이언트
--print(date("!%H") .. ":" .. date("!%M")) 서버
  
  if( date("%M")*1 + date("%S")*1 == 0 and SoW_Clock.OClock == true ) then
    PlaySoundFile("Interface\\AddOns\\SoW_Clock\\Sound\\O'Clock.ogg")
  end
  
  if( SoW_Clock.CleanTime ~= 0 ) then
    if( date("%M")*1%SoW_Clock.CleanTime == 0 and date("%S")*1 == 0) then
      MemClear()
    end
  end
  
	local I_DateText3 = l_WeekName[tonumber(date("%w")+1)]; -- 요일 표시
	
	DateString:SetText(l_DateText);
	TimeString:SetText(l_DateText1);
	TimeShadowString:SetText(l_DateText1);
	MidnSecString:SetText(l_DateText2);
	WeekString:SetText("|cFFFFFFFF[|r"..I_DateText3.."|cFFFFFFFF]|r");

	-- FPS & 메모리 & 네트웍지연율
	local l_mem_size = 0;
	l_mem_size = gcinfo() / 1024;
  
	local l_mem_color = "FFFFFF";
	if ( l_mem_size > 60 ) then
		l_mem_color = "FF0000";
	elseif ( l_mem_size > 50 ) then
		l_mem_color = "FF7E00";
	elseif ( l_mem_size > 40 ) then
		l_mem_color = "FFFF00";
	elseif ( l_mem_size > 30 ) then
		l_mem_color = "AAFF00";
	elseif ( l_mem_size > 20 ) then
		l_mem_color = "55FF00";
	else
		l_mem_color = "00FF00";
	end

	local l_fps = GetFramerate();
	local l_fps_Color = "FFFFFF";
	if ( l_fps > 45 ) then
		l_fps_color = "00FF00";
	elseif ( l_fps > 30 ) then
		l_fps_color = "66FF00";
	elseif ( l_fps > 20 ) then
		l_fps_color = "BBFF00";
	elseif ( l_fps > 15 ) then
		l_fps_color = "FFFF00";
	elseif ( l_fps > 10 ) then
		l_fps_color = "FF9900";
	else
		l_fps_color = "FF0000";
	end

	local l_NetIn, l_NetOut, l_latency = GetNetStats();
	local l_latency_color = "FFFFFF";
	if ( l_latency > 300 ) then
		l_latency_color = "FF0000";
	elseif ( l_latency > 250 ) then
		l_latency_color = "FF9900";
	elseif ( l_latency > 200 ) then
		l_latency_color = "FFFF00";
	elseif ( l_latency > 100 ) then
		l_latency_color = "BBFF00";
	elseif ( l_latency > 50 ) then
		l_latency_color = "66FF00";
	else
		l_latency_color = "00FF00";
	end

	local l_InfoText = string.format("|cff%s%.0f|c00FFFFFFfps", l_fps_color, GetFramerate())..string.format(" |cff%s%.1f|c00FFFFFFMiB", l_mem_color, l_mem_size)..string.format(" |cff%s%.0f|r|c00FFFFFFms", l_latency_color, l_latency);
	InfoString:SetText(l_InfoText);
	
	TimeSinceLastUpdate = date("%S");
	
	end
end)


-- 메모리 정리
function MemClear()
  local old = gcinfo();
	collectgarbage( 'collect' );
	local new	= gcinfo();
	local erased	= old - new;
	DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : " .. MemTex(erased) .. " |cFFFFFFFF정리됨|r");
	ResetCPUUsage()
	return;
end

-- 시계 프레임 클릭 스크립트
ClockFrame:SetScript("OnMouseDown", function()
	if (IsAltKeyDown() and IsShiftKeyDown()) then
	  if( StopwatchFrame:IsShown() )then
  	  StopwatchFrame:Hide();
  	else
  	  StopwatchFrame:Show();
	  end
	
	elseif (IsShiftKeyDown()) then
	  if not IsAddOnLoaded("Blizzard_Calendar") then
        LoadAddOn("Blizzard_Calendar")
		end
		Calendar_Toggle()
		
	elseif (IsAltKeyDown()) then
		ClockFrame:ClearAllPoints()
		ClockFrame:StartMoving()
		
	else
	  MemClear()
	end
end)
ClockFrame:SetScript("OnClick", function()
  
end)
ClockFrame:SetScript("OnMouseUp", function()
	ClockFrame:StopMovingOrSizing()
end)
ClockFrame:SetScript("OnEnter", function()
  TooltipShow(SoW_Clock.TipSet, SoW_Clock.TipList, SoW_Clock.MemSize)
end)

ClockFrame:SetScript("OnLeave", function()
  GameTooltip:Hide()
end)

function TooltipShow(ToolTipSet, ToolTipList, MemorySize)
  if ToolTipList > 0 then
    GameTooltip:SetOwner(ClockFrame, "ANCHOR_BOTTOMLEFT", 0, 0);
    
    if CalendarGetNumPendingInvites() > 0 then
      print("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |r미확인 일정이 있습니다.")
    end

    local memory, i, addons, total, CPUtotal, entry;
    
    GameTooltip:AddDoubleLine("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW C|cFFFFFFFFlock " .. Clock_Version, Clock_BuildDate);
    GameTooltip:AddLine("|cFFFFFFFF=====================================================|r")
    
    local s = 0
    local m = 0
    local h = 0
    local t = 0
    local c = 0
    
    if not IsInInstance() then -- 인던 입장 확인    
      SetMapZoom(4)
      local n = GetNumMapLandmarks()
      if n > 0 then
        for i = 1, n do
          local name, _, nr = GetMapLandmarkInfo(i)
          if name == "겨울손아귀 호수" then
            c = 1;
            if nr == 46 then
              GameTooltip:AddLine("|TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Alliance.tga:0:0:0:0|t|c000000FF얼라이언스|r가 차지 하였습니다.|r")
            elseif nr == 48 then
              GameTooltip:AddLine("|TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 |TInterface\\Addons\\SoW_Clock\\Icon\\Horde.tga:0:0:0:0|t|c00FF0000호드|r가 차지 하였습니다.|r")
            elseif nr == 101 then
              GameTooltip:AddLine("|TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀 호수|r를 차지하기 위한 |TInterface\\Icons\\Ability_DualWield:0:0:0:0|t|c00999999전투|r가 진행 중입니다.|r")
            end
          end
        end
        if c ~= 1 then
          GameTooltip:AddLine("현 장소에서는 |TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀|r |c00999999전투/소유|r 상황을 확인 할 수 없습니다.|r")
        end
      end
    
      t = GetWintergraspWaitTime()
      if t ~= nil then
        if ( t >= 3600 ) then
          h = floor(t/3600)
          m = floor((t%3600)/60)
          s = t%60
        elseif ( t >= 60 ) then
          m = floor(t/60)
          s = t%60
        else
          s = t
        end    
        
        if t > 0 then
          GameTooltip:AddDoubleLine("|TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀|r |TInterface\\Icons\\Ability_DualWield:0:0:0:0|t|c00999999전투|r 대기시간", "|cFFFFFFFF" .. h .. "|r시간 |cFFFFFFFF" .. m .. "|r분 |cFFFFFFFF" .. s .. "|r초")
        end
      end
      --
    elseif IsInInstance() then
      GameTooltip:AddLine("현 장소에서는 |TInterface\\Icons\\INV_Jewelry_Ring_66:0:0:0:0|t|cFFFFFFFF겨울손아귀|r |c00999999전투/소유|r 상황을 확인 할 수 없습니다.|r")
    end -- 겨손 관련 함수
    
    GameTooltip:AddLine("|cFFFFFFFF=====================================================|r")
          
    GameTooltip:AddLine("|cFFFFCC00Click : |c00FFFFFF메모리 정리");
    GameTooltip:AddLine("|cFFFFCC00Alt + Click : |c00FFFFFF시계 이동");
    GameTooltip:AddLine("|cFFFFCC00Shift + Click : |c00FFFFFF달력 열기");
    GameTooltip:AddLine("|cFFFFCC00Alt + Shift + Click : |c00FFFFFF초시계 열기");

    GameTooltip:AddLine("|cFFFFFFFF=====================================================|r")

    GameTooltip:AddDoubleLine("상위 |cFFFFFFFF" .. ToolTipList .. "|r개의 애드온", "메모리 사용량 / 메모리 비율 \| CPU 비율", 0, 0.6, 1, 1, 1, 0)

    GameTooltip:AddLine("|cFFFFFFFF=====================================================|r")

    addons = {}
   	local number = 0
  	total = 0
  	CPUtotal = 0
  	UpdateAddOnCPUUsage()
    UpdateAddOnMemoryUsage()
    for i = 1, GetNumAddOns(), 1 do
      if GetAddOnMemoryUsage(i) > 0 then
        cpu = GetAddOnCPUUsage(i)
        memory = GetAddOnMemoryUsage(i)
        entry = {name = GetAddOnInfo(i), memory = memory, cpu = cpu}
        table.insert(addons, entry)
        total = total + memory
        CPUtotal = CPUtotal + cpu
      end
    end
    
    if ( ToolTipSet == 0 ) then
      table.sort(addons, function(a, b) return a.memory > b.memory end)
    else
      table.sort(addons, function(a, b) return a.cpu > b.cpu end)
    end

    for _,entry in pairs(addons) do
  		if number < ToolTipList then
  			if number < 9 then
  				GameTooltip:AddDoubleLine("|cFFFFFFFF  " .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100) .. " |cFFFFCC00 \| |r |cFFFFFFFF" .. MemPerTex(entry.cpu/CPUtotal*100))
  			else
  				GameTooltip:AddDoubleLine("|cFFFFFFFF" .. number + 1 .. ". |cFFFFCC00"..entry.name, MemTex(entry.memory) .. " |cFFFFCC00/|r |cFFFFCC00" .. MemPerTex(entry.memory/total*100) .. " |cFFFFCC00 \| |r |cFFFFFFFF" .. MemPerTex(entry.cpu/CPUtotal*100))
  			end
  			number = number + 1
  		end
  	end
  	GameTooltip:AddLine("|cFFFFFFFF=====================================================|r")
  	
   GameTooltip:AddDoubleLine("사용자 애드온 합계", MemTex(total))
    GameTooltip:AddDoubleLine("블리자드 기본 UI 합계", MemTex(collectgarbage("count") - total))
    GameTooltip:AddDoubleLine("총 합계", MemTex(collectgarbage("count")))

  	GameTooltip:Show();
  	
  	ResetCPUUsage()
  	
  	if((collectgarbage("count") - total)/1024 > MemorySize) then
  	  DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFFFF와우 기본 UI 메모리 사용량이 " .. MemTex(collectgarbage("count") - total) .. "넘었습니다.\n재접속 하길 권장합니다.");
  	end
	end
end

function MenuListShow()

end

function MemPerTex(Num)
	local AddonMem
	if Num >= 50 then
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 40 then
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 30 then
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 20 then
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFF%"
	elseif Num >= 10 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 5 then
		AddonMem = "|cFFFFFF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	elseif Num > 2.5 then
		AddonMem = "|cFF88FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	else
		AddonMem = "|cFF00FF000" .. string.format("%.2f", Num).. " |cFFFFFFFF%"
	end

	return(AddonMem)
end

function MemTex(Num)
	local AddonMem
	if Num > 10240 then
		Num = Num/1024
		AddonMem = "|cFFFF0000" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 5120 then
		Num = Num/1024
		AddonMem = "|cFFFF4400" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 2048 then
		Num = Num/1024
		AddonMem = "|cFFFF8800" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 1024 then
		Num = Num/1024
		AddonMem = "|cFFFFAA00" .. string.format("%.2f", Num) .. " |cFFFFFFFFMiB"
	elseif Num > 786 then
		AddonMem = "|cFFFFCC00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	elseif Num > 512 then
		AddonMem = "|cFFFFFF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	elseif Num > 256 then
		AddonMem = "|cFF88FF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	else
		AddonMem = "|cFF00FF00" .. string.format("%.2f", Num).. " |cFFFFFFFFKiB"
	end

	return(AddonMem)
end

-- 명령어 모음
SLASH_Clock1 = "/sc"
SLASH_Clock2 = "/ㅅㄱ"
SLASH_Clock3 = "/ㄴㅊ";
SLASH_Clock4 = "/swc";
SlashCmdList["Clock"] = function(cmd)
  msg = strtrim(cmd);
	cmd = gsub(msg, "(.*)@(.*)", "%1");
	argument = gsub(msg, "(.*)@(.*)", "%2");
	if cmd == "sc" or cmd == "scale" or cmd == "크기" or cmd == "ㅋㄱ" then
	  SoW_Clock.Scale = argument*1;
	  SoW_Clock_Frame:SetScale(SoW_Clock.Scale*1)
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온의 크기 비율을 |r" .. argument .. "|cFFFFFFFF로 설정합니다.|r");
		
	elseif cmd == "ts" or cmd =="tipset" or cmd == "ㅈㄹ" or cmd == "정렬" then
	  SoW_Clock.TipSet = argument*1;
	  if (argument*1 == 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF목록을 메모리 비율순으로 정렬합니다.|r");
	  
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF목록을 CPU 비율순으로 정렬합니다.|r");
	  end
		
	elseif cmd == "tl" or cmd == "tiplist" or cmd == "ㅁㄹ" or cmd == "목록" then
	  SoW_Clock.TipList = argument*1;
	  if(SoW_Clock.TipList > 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 목록 갯수를 |r" .. SoW_Clock.TipList .. "|cFFFFFFFF개로 설정합니다.|r");
	  elseif(SoW_Clock.TipList == 0) then
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 툴팁을 비활성화합니다.|r");
	  else
	    SoW_Clock.TipList = 30;
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF애드온 목록 갯수를 기본값인 |r" .. SoW_Clock.TipList .. "|cFFFFFFFF개로 설정합니다.|r");
	  end
	  
	elseif cmd == "ms" or cmd =="memsize" or cmd == "ㅁㅋ" or cmd == "메모리크기" then
	  if (argument*1 >= 0) then
	    SoW_Clock.MemSize = argument*1;
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF와우 기본 UI 사용 메모리 경고량을 |r" .. SoW_Clock.MemSize .. "|cFFFFFFFFMiB로 설정합니다.|r");
	  
	  else
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF잘못된 값을 입력하였습니다. 확인 후 다시 입력하시기 바랍니다.");
	  end
		
	elseif (cmd == "tt" or cmd == "timetype" or cmd == "ㅅㅅ" or cmd == "시간표시설정") then
	  if (argument*1 == 0) then
		  DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF시간 표시방식을 |r|cFFFFFF0012시간 단위 및 오전/후 표시|r |cFFFFFFFF로 설정 합니다.|r");
		  SoW_Clock.TimeType = 0;
		
	  else
		  DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFFFFFFFF시간 표시방식을 |r|cFFFFFF0024시간 단위 및 초 표시|r |cFFFFFFFF로 설정 합니다.|r");
		  SoW_Clock.TimeType = 1;
		end
		
	elseif cmd == "oc" or cmd == "ㅈㅅ" then
    if (argument*1 == 1) then
      SoW_Clock.OClock = true
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 정시 알림을 사용합니다.");
    else
      SoW_Clock.OClock = false
      DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 정시 알림을 해제합니다.");
	  end
	  
	elseif cmd == "ct" or cmd == "ㅊㅅ" then
	  if(argument*1 >= 0) then
	    SoW_Clock.CleanTime = argument*1
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : |cFF00AAFF" .. argument*1 .. "|r분 간격으로 메모리 정리를 실행합니다.");
	  else
	    SoW_Clock.CleanTime = 0
	    DEFAULT_CHAT_FRAME:AddMessage("|cFF00AAFFS|cFFFFFFFFo|cFF00AAFFW|r |cFF00AAFFC|cFFFFFFFFlock : 메모리 자동 정리 기능을 해제합니다.");
	  end
	  
	else
  	MemClear()
	end
end
