﻿local addon = ...

local frame = CreateFrame("Frame", addon .. "ConfigFrame", InterfaceOptionsFramePanelContainer)
frame.name = addon
frame:Hide()
frame:SetScript("OnShow", function(frame)
  local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
  title:SetPoint("TOPLEFT", 16, -16)
  title:SetText("CoW_Clock Config")

  local subtitle = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
  subtitle:SetHeight(35)
  subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
  subtitle:SetPoint("RIGHT", frame, -32, 0)
  subtitle:SetNonSpaceWrap(true)
  subtitle:SetJustifyH("LEFT")
  subtitle:SetJustifyV("TOP")
  subtitle:SetText("SoW_Clock 의 설정들을 수정 할 수 있습니다.")
  
  -- 정시 알림 설정
  CreateFrame("CheckButton", "SoW_Clock_OptionsFrame_OClockWindow", frame, "InterfaceOptionsCheckButtonTemplate")
	  SoW_Clock_OptionsFrame_OClockWindow:SetPoint("TOPLEFT", 16, -60)
  	SoW_Clock_OptionsFrame_OClockWindowText:SetText("정시 알림")
  	SoW_Clock_OptionsFrame_OClockWindow:SetScript("OnClick", function(self)
  	if SoW_Clock.OClock then
  		SoW_Clock.OClock = false
  	else
  		SoW_Clock.OClock = true
  	end
  	self:SetChecked(SoW_Clock.OClock)
  end)
	
	-- Scale slider
	local ScaleText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
  ScaleText:SetPoint("TOPLEFT", 16, -95)
  ScaleText:SetText("크기 비율")
	CreateFrame("Slider", "SoW_Clock_ScaleSlider", frame, "OptionsSliderTemplate")
	SoW_Clock_ScaleSlider:SetWidth(200)
	SoW_Clock_ScaleSlider:SetHeight(16)
	SoW_Clock_ScaleSlider:SetPoint("TOPLEFT", 25, -120)
	SoW_Clock_ScaleSliderText:SetFormattedText("Scaling %d%%", SoW_Clock.Scale*100)
	SoW_Clock_ScaleSliderLow:SetText("50%")
	SoW_Clock_ScaleSliderHigh:SetText("200%")
	SoW_Clock_ScaleSlider:SetMinMaxValues(50, 200)
	SoW_Clock_ScaleSlider:SetValueStep(1)
	SoW_Clock_ScaleSlider:SetScript("OnValueChanged", function(self, value)
		SoW_Clock_ScaleSliderText:SetFormattedText("Scaling %d%%", value)
		SoW_Clock.Scale = value/100
		SoW_Clock_Frame:SetScale(value / 100)
	end)
	
	-- 애드온 표시 갯수 slider
	local TipListText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
  TipListText:SetPoint("TOPLEFT", 16, -160)
  TipListText:SetText("애드온 표시 갯수")
	CreateFrame("Slider", "SoW_Clock_TipListSlider", frame, "OptionsSliderTemplate")
	SoW_Clock_TipListSlider:SetWidth(200)
	SoW_Clock_TipListSlider:SetHeight(16)
	SoW_Clock_TipListSlider:SetPoint("TOPLEFT", 25, -185)
	if SoW_Clock.TipList ~= 0 then
  	SoW_Clock_TipListSliderText:SetFormattedText("표시할 애드온 목록 갯수 %d 개", SoW_Clock.TipList)
  else
    SoW_Clock_TipListSliderText:SetFormattedText("툴팁을 비활성화 합니다.")
  end
	SoW_Clock_TipListSliderLow:SetText("0(툴팁 비활성)")
	SoW_Clock_TipListSliderHigh:SetText("50개")
	SoW_Clock_TipListSlider:SetMinMaxValues(0, 50)
	SoW_Clock_TipListSlider:SetValueStep(1)
	SoW_Clock_TipListSlider:SetScript("OnValueChanged", function(self, value)
		if value ~= 0 then
  	  SoW_Clock_TipListSliderText:SetFormattedText("표시할 애드온 목록 갯수 %d 개", value)
    else
      SoW_Clock_TipListSliderText:SetFormattedText("툴팁을 비활성화 합니다.")
    end
		SoW_Clock.TipList = value
	end)
	
	-- 와우UI 사용량 경고 slider
	local MemSizeText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
  MemSizeText:SetPoint("TOPLEFT", 315, -95)
  MemSizeText:SetText("와우 UI 메모리 경고량")
	CreateFrame("Slider", "SoW_Clock_MemSizeSlider", frame, "OptionsSliderTemplate")
	SoW_Clock_MemSizeSlider:SetWidth(200)
	SoW_Clock_MemSizeSlider:SetHeight(16)
	SoW_Clock_MemSizeSlider:SetPoint("TOPRIGHT", -25, -120)
	if SoW_Clock.MemSize ~= 0 then
  	SoW_Clock_MemSizeSliderText:SetFormattedText("와우 UI 메모리 경고량 %d MiB", SoW_Clock.TipList)
  else
    SoW_Clock_MemSizeSliderText:SetFormattedText("경고를 비활성화 합니다.")
  end
	SoW_Clock_MemSizeSliderLow:SetText("0(비활성화)")
	SoW_Clock_MemSizeSliderHigh:SetText("50MiB")
	SoW_Clock_MemSizeSlider:SetMinMaxValues(0, 50)
	SoW_Clock_MemSizeSlider:SetValueStep(1)
	SoW_Clock_MemSizeSlider:SetScript("OnValueChanged", function(self, value)
		if value ~= 0 then
  	SoW_Clock_MemSizeSliderText:SetFormattedText("와우 UI 메모리 경고량 %d MiB", value)
  else
    SoW_Clock_MemSizeSliderText:SetFormattedText("경고를 비활성화 합니다.")
    end
		SoW_Clock.MemSize = value
	end)
	
	-- 자동 청소 간격 설정 slider
	local CleanTimeText = frame:CreateFontString(nil, "ARTWORK", "GameFontNormal")
  CleanTimeText:SetPoint("TOPLEFT", 315, -160)
  CleanTimeText:SetText("메모리 자동 청소 간격")
	CreateFrame("Slider", "SoW_Clock_CleanTimeSlider", frame, "OptionsSliderTemplate")
	SoW_Clock_CleanTimeSlider:SetWidth(200)
	SoW_Clock_CleanTimeSlider:SetHeight(16)
	SoW_Clock_CleanTimeSlider:SetPoint("TOPRIGHT", -25, -185)
	if SoW_Clock.CleanTime ~= 0 then
  	SoW_Clock_CleanTimeSliderText:SetFormattedText("메모리 청소 간격 %d 분", SoW_Clock.CleanTime)
  else
    SoW_Clock_CleanTimeSliderText:SetFormattedText("자동 청소를 비활성화 합니다.")
  end
	SoW_Clock_CleanTimeSliderLow:SetText("0(비활성화)")
	SoW_Clock_CleanTimeSliderHigh:SetText("60분")
	SoW_Clock_CleanTimeSlider:SetMinMaxValues(0, 60)
	SoW_Clock_CleanTimeSlider:SetValueStep(1)
	SoW_Clock_CleanTimeSlider:SetScript("OnValueChanged", function(self, value)
		if value ~= 0 then
  	SoW_Clock_CleanTimeSliderText:SetFormattedText("메모리 청소 간격 %d 분", value)
  else
    SoW_Clock_CleanTimeSliderText:SetFormattedText("자동 청소를 비활성화 합니다.")
    end
		SoW_Clock.CleanTime = value
	end)
	
	CreateFrame("Frame", "SoW_Clock_TimeTypeDropDown", frame, "UIDropDownMenuTemplate")
  SoW_Clock_TimeTypeDropDown:SetPoint("TOPLEFT", 6, -245)
	SoW_Clock_TimeTypeDropDown:CreateFontString("SoW_Clock_TimeTypeDropDownLabel", "BACKGROUND", "GameFontNormalSmall")
	SoW_Clock_TimeTypeDropDownLabel:SetPoint("BOTTOMLEFT", SoW_Clock_TimeTypeDropDown, "TOPLEFT", 21, 1)
	SoW_Clock_TimeTypeDropDownLabel:SetText("시각 표시 방식")
	SoW_Clock_TimeTypeDropDown.initialize = function()
  	local function onClick(self)
  		UIDropDownMenu_SetSelectedValue(SoW_Clock_TimeTypeDropDown, self.value)
  		SoW_Clock.TimeType = self.value
  	end
  	
  	local info = {}		
  		wipe(info)
  		info.text = "12시간 표시 단위"
  		info.value = 0
  		info.func = onClick
  		UIDropDownMenu_AddButton(info)
  		
  		wipe(info)
  		info.text = "24시간 표시 단위"
  		info.value = 1
  		info.func = onClick
  		UIDropDownMenu_AddButton(info)
	end
	
	CreateFrame("Frame", "SoW_Clock_TipSetDropDown", frame, "UIDropDownMenuTemplate")
  SoW_Clock_TipSetDropDown:SetPoint("TOPLEFT", 175, -245)
	SoW_Clock_TipSetDropDown:CreateFontString("SoW_Clock_TipSetDropDownLabel", "BACKGROUND", "GameFontNormalSmall")
	SoW_Clock_TipSetDropDownLabel:SetPoint("BOTTOMLEFT", SoW_Clock_TipSetDropDown, "TOPLEFT", 21, 1)
	SoW_Clock_TipSetDropDownLabel:SetText("애드온 목록 정렬 방식")
	SoW_Clock_TipSetDropDown.initialize = function()
  	local function onClick(self)
  		UIDropDownMenu_SetSelectedValue(SoW_Clock_TipSetDropDown, self.value)
  		SoW_Clock.TipSet = self.value
  	end
  	
  	local info = {}		
  		wipe(info)
  		info.text = "메모리 사용량 비율"
  		info.value = 0
  		info.func = onClick
  		UIDropDownMenu_AddButton(info)
  		
  		wipe(info)
  		info.text = "CPU 사용량 비율"
  		info.value = 1
  		info.func = onClick
  		UIDropDownMenu_AddButton(info)
	end
	
	  -- 설정 초기화
  CreateFrame("Button", "SoW_Clock_OptionsFrame_ResetWTF", frame, "OptionsButtonTemplate")
	SoW_Clock_OptionsFrame_ResetWTF:SetPoint("TOPRIGHT", -16, -245)
	SoW_Clock_OptionsFrame_ResetWTF:SetWidth(155)
 	SoW_Clock_OptionsFrame_ResetWTF:SetText("SoW_Clock 설정 초기화")
 	SoW_Clock_OptionsFrame_ResetWTF:SetScript("OnClick", function(self)
  	SoW_Clock.MemSet = 0; -- 메모리 표시 종류 설정| 0=통합, 1=애드온, 2=와우기본UI
  	SoW_Clock.MemSize = 25; -- 경고 시작할 메모리 용량
  	SoW_Clock.TipSet = 0; -- 툴팁 표시 설정 | 0 = 메모리, 1 = CPU
  	SoW_Clock.TipList = 30; -- 애드온 표시 리스트 갯수 설정
  	SoW_Clock.TimeType = 0; -- 시간 표시 방법 설정 | 0 = 12시간 단위, 1 = 24시간 단위
  	SoW_Clock.Scale = 1; -- 애드온의 크기 비율
  	SoW_Clock.OClock = true; -- 정시 알림 소리 설정 | false = 미사용, true = 사용
  	SoW_Clock.CleanTime = 5; -- 자동 메모리 정리 간격 | 단위는 분, 0일 경우 미사용
  end)
  
  -- UI 재시작
  CreateFrame("Button", "SoW_Clock_OptionsFrame_ResetUI", frame, "OptionsButtonTemplate")
	SoW_Clock_OptionsFrame_ResetUI:SetPoint("TOPRIGHT", -16, -275)
	SoW_Clock_OptionsFrame_ResetUI:SetWidth(155)
 	SoW_Clock_OptionsFrame_ResetUI:SetText("블리자드 UI 재시작")
 	SoW_Clock_OptionsFrame_ResetUI:SetScript("OnClick", function(self)
 	  ReloadUI();
  end)
  
  CreateFrame("Button", "URLFrame", frame) 
  URLFrame:SetPoint("BOTTOMLEFT", 14, 14)
  URLFrame:SetHeight(30)
  URLFrame:SetWidth(200)
  local URLText = frame:CreateFontString(nil, "OVERLAY")
  URLText:SetPoint("BOTTOMLEFT", 16, 16)
  URLText:SetFont("Interface\\AddOns\\SoW_Clock\\Font\\HARLOWSI.TTF", 26)
  URLText:SetTextColor(0,0.6,1)
  URLText:SetText("http://lusiyan.wo.tc")
  URLFrame:SetScript("OnClick", function()
 	  SoW_Clock_URL_At_ChatBox()
  end)

  local Refresh;
  function Refresh()
    if not frame:IsVisible() then 
      return 
    end
    
		UIDropDownMenu_SetSelectedValue(SoW_Clock_TimeTypeDropDown, SoW_Clock.TimeType)
    if( SoW_Clock.TimeType == 0 ) then
		  SoW_Clock_TimeTypeDropDownText:SetText("12시간 표시 단위")
		elseif( SoW_Clock.TimeType == 1 ) then
			SoW_Clock_TimeTypeDropDownText:SetText("24시간 표시 단위")
		end
		UIDropDownMenu_SetSelectedValue(SoW_Clock_TipSetDropDown, SoW_Clock.TipSet)
    if( SoW_Clock.TipSet == 0 ) then
		  SoW_Clock_TipSetDropDownText:SetText("메모리 사용량 비율")
		elseif( SoW_Clock.TipSet == 1 ) then
			SoW_Clock_TipSetDropDownText:SetText("CPU 사용량 비율")
		end
   	SoW_Clock_OptionsFrame_OClockWindow:SetChecked(SoW_Clock.OClock)
    SoW_Clock_ScaleSlider:SetValue(SoW_Clock.Scale*100)
    SoW_Clock_TipListSlider:SetValue(SoW_Clock.TipList)
    SoW_Clock_MemSizeSlider:SetValue(SoW_Clock.MemSize)
    SoW_Clock_CleanTimeSlider:SetValue(SoW_Clock.CleanTime)
  end

  frame:SetScript("OnShow", Refresh) 
  Refresh()
end)

InterfaceOptions_AddCategory(frame)


function SoW_Clock_URL_At_ChatBox()
	ChatFrame1EditBox:SetText("http://lusiyan.wo.tc")
	if not ChatFrame1EditBox:IsShown() then
	  ChatFrame1EditBox:Show();
	end
	
	ChatFrame1EditBox:HighlightText()
end
